#!/bin/bash

CARD_IDX="-1"

#lenovo:
if dmidecode -t bios | grep -i vendor | grep -i lenovo ; then
    if dmidecode -t processor | grep -i version | grep -i N4020 ; then
        CARD_IDX="0"
    elif dmidecode -t processor | grep -i version | grep -i N5030 ; then
        CARD_IDX="0"
    fi
fi

#mig:
if dmidecode -t bios | grep -i vendor | grep -i egatrends ; then
    if dmidecode -t processor | grep -i version | grep -i N3450 ; then
        CARD_IDX="2"
    elif dmidecode -t processor | grep -i version | grep -i N5100 ; then
        CARD_IDX="2"
    fi
fi

if [[ $CARD_IDX == "-1" ]]; then
    exit 0
fi

export PATH=/usr/bin

AUDIO_OUTPUT="analog-stereo"
USER_NAME=$(who | grep " :0 " | cut -f1 -d' ')
USER_ID=$(id -u "$USER_NAME")
CARD_PATH="/sys/class/drm/card0/"
PULSE_SERVER="unix:/run/user/"$USER_ID"/pulse/native"

for OUTPUT in $(cd "$CARD_PATH" && echo card*); do
  OUT_STATUS=$(<"$CARD_PATH"/"$OUTPUT"/status)
  if [[ $OUT_STATUS == connected ]]; then
    case "$OUTPUT" in
      "card0-HDMI-A-1")
        AUDIO_OUTPUT="hdmi-stereo" # Digital Stereo (HDMI 1)
     ;;
      "card0-HDMI-A-2")
        AUDIO_OUTPUT="hdmi-stereo-extra1" # Digital Stereo (HDMI 2)
     ;;
      "card0-DP-1")
        AUDIO_OUTPUT="hdmi-stereo" # Digital Stereo (DP-*)
     ;;
      "card0-DP-2")
        AUDIO_OUTPUT="hdmi-stereo" # Digital Stereo (DP-*)
    esac
  fi
done

sudo -u "$USER_NAME" pactl --server "$PULSE_SERVER" set-card-profile $CARD_IDX output:$AUDIO_OUTPUT+input:analog-stereo
