#!/bin/bash

if [[ $EUID -ne 0 ]]; then
    echo "Please run the script as superuser."
    exit 1
fi

declare -a CONFIGS=(
    '/etc/systemd/system.conf'
    '/etc/systemd/user.conf'
)
declare SECTION='Manager'
declare KEY='DefaultTimeoutStopSec'
declare VALUE=''

if [ -z "$1" ]; then VALUE='5s'; else VALUE="$1s"; fi



for CONFIG_PATH in "${CONFIGS[@]}"
do
    sed -i "/^\[$SECTION\]$/,/^\[/ s!^$KEY=.*!$KEY=$VALUE!" "$CONFIG_PATH"
    sed -i "/^\[$SECTION\]$/,/^\[/ s!^#$KEY=.*!$KEY=$VALUE!" "$CONFIG_PATH"
done

